package net.sf.cpsolver.coursett.criteria;


import net.sf.cpsolver.coursett.Constants;
import net.sf.cpsolver.coursett.model.Placement;

/**
 * Time violations. This criterion counts how many times a prohibited time is assigned
 * to a class in interactive timetabling.
 * <br>
 * 
 * @version CourseTT 1.2 (University Course Timetabling)<br>
 *          Copyright (C) 2006 - 2011 Tomas Muller<br>
 *          <a href="mailto:muller@unitime.org">muller@unitime.org</a><br>
 *          <a href="http://muller.unitime.org">http://muller.unitime.org</a><br>
 * <br>
 *          This library is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU Lesser General Public License as
 *          published by the Free Software Foundation; either version 3 of the
 *          License, or (at your option) any later version. <br>
 * <br>
 *          This library is distributed in the hope that it will be useful, but
 *          WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *          Lesser General Public License for more details. <br>
 * <br>
 *          You should have received a copy of the GNU Lesser General Public
 *          License along with this library; if not see
 *          <a href='http://www.gnu.org/licenses/'>http://www.gnu.org/licenses/</a>.
 */
public class TimeViolations extends RoomViolations {

    @Override
    protected boolean violation(Placement value) {
        int pref = value.getTimeLocation().getPreference();
        return pref > Constants.sPreferenceLevelProhibited / 2;
    }

}
